% Some tests for fast companion QZ (uncomment as needed).
% 

% % TEST 1 : random complex polynomials.

% n=100;
% n_trials=10;
% errors=zeros(n_trials,1);
% iterations=zeros(n_trials,1);
% for k_index=1:n_trials
%     display(k_index)
% PP=(2*rand(n+1,1)-1)+i*(2*rand(n+1,1)-1);
% P=PP/norm(PP);
% fast_companion_QZ
% roots_matrix_bal=roots(PP);
% %roots_matrix_nobal=eig(compan(PP),'nobalance');
% %roots_pencil=eig(A0,B0);
% myroots=adiag./bdiag;
% errors(k_index)=AbsDistance(myroots,roots_matrix_bal);
% %RelDistance(myroots,roots_matrix_bal)
% iterations(k_index)=total_it/n;
% end
% mean(errors)
% mean(iterations)


% % TEST 2 : cyclotomic polynomials z^n-i.

n=100;
P=[1;zeros(n-1,1);-i];
fast_companion_QZ
roots_matrix_bal=roots(P);
roots_matrix_nobal=eig(compan(P),'nobalance');
roots_pencil=eig(A0,B0);
myroots=adiag./bdiag;
AbsDistance(myroots,roots_matrix_bal)
RelDistance(myroots,roots_matrix_bal)
total_it/n

 
% % TEST 3 : polynomial with 20 given roots 
% % (requires Symbolic Toolbox, uncomment as needed)

% d=60;
 % exact_roots=1./(1:20);
 % kk=-10:9; exact_roots=2*pi./(19*(kk+0.5))+1i*sin(2*pi./(19*(kk+0.5)));
 % exact_roots=-1.9:0.2:1.9;
 % exact_roots=2.^(-10:9);
% ppp=compute_coeff_vpa(exact_roots,d);
% pp=ppp/norm(double(ppp));   % normalize polynomial
% P=double(pp);
%  Aa=[-(P(2:21));eye(19),zeros(19,1)];
%  Bb=eye(20);
%  Bb(1,1)=P(1);
%  fast_companion_QZ;
%  myroots=adiag./bdiag;
%  roots_matrix_bal=roots(P);
%  roots_matrix_nobal=eig(compan(P),'nobalance');
%  roots_matrix_bal_nonorm=eig(compan(double(ppp)));
%  roots_pencil=eig(Aa,Bb);
%  % compute and print forward errors
%  fprintf('Forward errors for fast QZ : \n')
%  AbsDistance(myroots,exact_roots)
%  RelDistance(myroots,exact_roots)
%  fprintf('Forward errors for classical QZ : \n')
%  AbsDistance(roots_pencil,exact_roots)
%  RelDistance(roots_pencil,exact_roots)
%  fprintf('Forward errors for balanced QR : \n')
%  AbsDistance(roots_matrix_bal,exact_roots)
%  RelDistance(roots_matrix_bal,exact_roots)
%  fprintf('Forward errors for balanced QR without normalization: \n')
%  AbsDistance(roots_matrix_bal_nonorm,exact_roots)
%  RelDistance(roots_matrix_bal_nonorm,exact_roots)
%  fprintf('Forward errors for unbalanced QR : \n')
%  AbsDistance(roots_matrix_nobal,exact_roots)
%  RelDistance(roots_matrix_nobal,exact_roots)
%  % compute and print backward errors (polynomials are monic)
%  mycoeff=compute_coeff_vpa(myroots,d);
%  coeff_matrix_bal=compute_coeff_vpa(roots_matrix_bal,d);
%  coeff_matrix_nobal=compute_coeff_vpa(roots_matrix_nobal,d);
%  coeff_pencil=compute_coeff_vpa(roots_pencil,d);
%  % normalize polynomials w.r.t. 2-norm
%  mycoeff2=mycoeff/norm(mycoeff);
%  coeff_matrix_bal2=coeff_matrix_bal/norm(coeff_matrix_bal);
%  coeff_matrix_nobal2=coeff_matrix_nobal/norm(coeff_matrix_nobal);
%  coeff_pencil2=coeff_pencil/norm(coeff_pencil);
%  fprintf('Backward errors for fast QZ : \n')
%  norm(double(mycoeff2)-P,'inf')
%  norm((double(mycoeff2)-P)./P,'inf')
%  fprintf('Backward errors for classical QZ : \n')
%  norm(double(coeff_pencil2)-P,'inf')
%  norm((double(coeff_pencil2)-P)./P,'inf')
%  fprintf('Backward errors for balanced QR : \n')
%  norm(double(coeff_matrix_bal2)-P,'inf')
%  norm((double(coeff_matrix_bal2)-P)./P,'inf')
%  fprintf('Backward errors for unbalanced QR : \n')
%  norm(double(coeff_matrix_nobal2)-P,'inf')
%  norm((double(coeff_matrix_nobal2)-P)./P,'inf')
%  % normalize polynomials w.r.t. least squares
%  a=P.';
%  ahat=double(mycoeff).';
%  tau=(ahat'*a)/(ahat'*ahat);
%  mycoeff3=mycoeff*tau;
%  ahat=double(coeff_matrix_bal).';
%  tau=(ahat'*a)/(ahat'*ahat);
%  coeff_matrix_bal3=coeff_matrix_bal*tau;
%  ahat=double(coeff_matrix_nobal).';
%  tau=(ahat'*a)/(ahat'*ahat);
%  coeff_matrix_nobal3=coeff_matrix_nobal*tau;
%  ahat=double(coeff_pencil).';
%  tau=(ahat'*a)/(ahat'*ahat);
%  coeff_pencil3=coeff_pencil*tau;
%  fprintf('LS Backward errors for fast QZ : \n')
%  norm(double(mycoeff3)-P,'inf')
%  norm((double(mycoeff3)-P)./P,'inf')
%  fprintf('LS Backward errors for classical QZ : \n')
%  norm(double(coeff_pencil3)-P,'inf')
%  norm((double(coeff_pencil3)-P)./P,'inf')
%  fprintf('LS Backward errors for balanced QR : \n')
%  norm(double(coeff_matrix_bal3)-P,'inf')
%  norm((double(coeff_matrix_bal3)-P)./P,'inf')
%  fprintf('LS Backward errors for unbalanced QR : \n')
%  norm(double(coeff_matrix_nobal3)-P,'inf')
%  norm((double(coeff_matrix_nobal3)-P)./P,'inf')



% %  TEST 4 : polynomial of degree 20 with given coefficients 
% % (requires Symbolic Toolbox), uncomment as needed

% d=60;
%  p=ones(1,21);
% % p=chebyshev_poly(20);
% % p=bernoulli_poly(20);
% n=20;
% ps=num2str(p(n+1));
% for j=1:n
%     ps=strcat(ps,'+',num2str(p(n-j+1)),'*x^',num2str(j));
% end
% symb_roots=solve(ps);
% exact_roots=double(symb_roots);
% 
% roots_matrix_bal_nonorm=roots(p);
% roots_matrix_nobal_nonorm=eig(compan(p),'nobalance');
% pp=p;
% P=p/norm(p);   % normalize polynomial
% Aa=[-(P(2:n+1));eye(n-1),zeros(n-1,1)];
%  Bb=eye(n);
%  Bb(1,1)=P(1);
%  fast_companion_QZ;
%  myroots=adiag./bdiag;
%  roots_matrix_bal=roots(P);
%  roots_matrix_nobal=eig(compan(P),'nobalance');
%  roots_pencil=eig(Aa,Bb);
%  % compute and print forward errors
%  fprintf('Forward errors for fast QZ : \n')
%  AbsDistance(myroots,exact_roots)
%  RelDistance(myroots,exact_roots)
%  fprintf('Forward errors for classical QZ : \n')
%  AbsDistance(roots_pencil,exact_roots)
%  RelDistance(roots_pencil,exact_roots)
%  fprintf('Forward errors for balanced QR : \n')
%  AbsDistance(roots_matrix_bal,exact_roots)
%  RelDistance(roots_matrix_bal,exact_roots)
%  fprintf('Forward errors for balanced QR without normalization: \n')
%  AbsDistance(roots_matrix_bal_nonorm,exact_roots)
%  RelDistance(roots_matrix_bal_nonorm,exact_roots)
%  fprintf('Forward errors for unbalanced QR : \n')
%  AbsDistance(roots_matrix_nobal,exact_roots)
%  RelDistance(roots_matrix_nobal,exact_roots)
%  fprintf('Forward errors for unbalanced QR without normalization: \n')
%  AbsDistance(roots_matrix_nobal_nonorm,exact_roots)
%  RelDistance(roots_matrix_nobal_nonorm,exact_roots)
%  % compute and print backward errors (polynomials are monic)
%  mycoeff=compute_coeff_vpa(myroots,d);
%  coeff_matrix_bal=compute_coeff_vpa(roots_matrix_bal,d);
%  coeff_matrix_nobal=compute_coeff_vpa(roots_matrix_nobal,d);
%  coeff_matrix_bal_nonorm=compute_coeff_vpa(roots_matrix_bal_nonorm,d);
%  coeff_matrix_nobal_nonorm=compute_coeff_vpa(roots_matrix_nobal_nonorm,d);
%  coeff_pencil=compute_coeff_vpa(roots_pencil,d);
%  % normalize polynomials w.r.t. 2-norm
%  mycoeff2=mycoeff/norm(mycoeff);
%  coeff_matrix_bal2=coeff_matrix_bal/norm(coeff_matrix_bal);
%  coeff_matrix_nobal2=coeff_matrix_nobal/norm(coeff_matrix_nobal);
%  coeff_matrix_bal2_nonorm=coeff_matrix_bal_nonorm/norm(coeff_matrix_bal_nonorm);
%  coeff_matrix_nobal2_nonorm=coeff_matrix_nobal_nonorm/norm(coeff_matrix_nobal_nonorm);
%  coeff_pencil2=coeff_pencil/norm(coeff_pencil);
%  fprintf('Backward errors for fast QZ : \n')
%  norm(double(mycoeff2)-P,'inf')
%  norm((double(mycoeff2)-P)./P,'inf')
%  fprintf('Backward errors for classical QZ : \n')
%  norm(double(coeff_pencil2)-P,'inf')
%  norm((double(coeff_pencil2)-P)./P,'inf')
%  fprintf('Backward errors for balanced QR with normalization: \n')
%  norm(double(coeff_matrix_bal2)-P,'inf')
%  norm((double(coeff_matrix_bal2)-P)./P,'inf')
%  fprintf('Backward errors for balanced QR without normalization: \n')
%  norm(double(coeff_matrix_bal2_nonorm)-P,'inf')
%  norm((double(coeff_matrix_bal2_nonorm)-P)./P,'inf')
%  fprintf('Backward errors for unbalanced QR : \n')
%  norm(double(coeff_matrix_nobal2)-P,'inf')
%  norm((double(coeff_matrix_nobal2)-P)./P,'inf')
%  fprintf('Backward errors for unbalanced QR without normalization: \n')
%  norm(double(coeff_matrix_nobal2_nonorm)-P,'inf')
%  norm((double(coeff_matrix_nobal2_nonorm)-P)./P,'inf')
% 




% % TEST 5 : truncated Fourier series with exponentially decaying
% % coefficients (see Boyd, Section 2.2).

% nn=50;
% n=2*nn;
% a=2*(rand(nn+1,1)-1);
% b=2*(rand(nn+1,1)-1);  % a and b are coefficients of a Fourier series
% a=a.*(exp(-0.1*[1:nn+1]'));
% b=b.*(exp(-0.1*[1:nn+1]'));
% % compute associated polynomial 
% P=zeros(n+1,1);
% P(nn+1)=a(1);
% P(1:nn)=(a(nn:-1:1)+i*b(nn:-1:1))/2;
% P(nn+2:n+1)=(a(1:nn)-i*b(1:nn))/2;
% P=flipud(P);
% % normalize w.r.t. 2-norm:
% P=P/(sign(P(1))*norm(P));
% fast_companion_QZ 
% roots_matrix_bal=roots(P);
% roots_matrix_nobal=eig(compan(P),'nobalance');
% roots_pencil=eig(A0,B0);
% myroots=adiag./bdiag;
% fprintf('Forward errors for fast QZ : \n')
% AbsDistance(myroots,roots_matrix_bal)
% RelDistance(myroots,roots_matrix_bal)
% total_it/n
% fprintf('Backward abs error for fast QZ : \n')
% mycoeff=compute_coeff_vpa(myroots,200);
% mycoeff2=mycoeff/norm(double(mycoeff));
% a=P;
% ahat=double(mycoeff).';
% tau=(ahat'*a)/(ahat'*ahat);
% mycoeff3=mycoeff*tau;
% norm((double(mycoeff3).'-P),'inf')
% fprintf('Backward abs error for balanced QR : \n')
% coeff_matrix_bal=compute_coeff_vpa(roots_matrix_bal,200);
% coeff_matrix_bal2=coeff_matrix_bal/norm(double(coeff_matrix_bal));
% ahat=double(coeff_matrix_bal).';
% tau=(ahat'*a)/(ahat'*ahat);
% coeff_matrix_bal3=coeff_matrix_bal*tau;
% norm((double(coeff_matrix_bal3).'-P),'inf')
% fprintf('Forward errors for unbalanced QR : \n')
% AbsDistance(roots_matrix_nobal,roots_matrix_bal)